
function auc = calculate_auc(targets, predicts)
	% Calculate area under the ROC curve
	if nargin > 1
		[values,i] = sort(predicts,'descend');
		targets = targets(i);
	end
	
	%for i=1:n
	%	if targets(i)
	%		goods = goods + 1
	%	else
	%		auc = auc + goods;
	%	end
	%end
	cumsums = cumsum(targets);
	auc = sum(cumsums(~targets));
	pos = sum(targets);
	neg = sum(~targets);
	if pos == 0, warning('Calculate auc: no positive targets'); end
	if neg == 0, warning('Calculate auc: no negative targets'); end
	auc = auc / (pos * neg + eps);
end
