function [fun,full_name] = method_by_name(name, varargin)
	% Get a prediction method given its name
	full_name = name;
	
	opts = struct(varargin{:});
	if ~isfield(opts,'cv_type') opts.cv_type = 'pairs'; end
	
	if isequal(name, 'adjacent')
		fun = predict_num_adjacent();
	elseif isequal(name, 'adjacent-cheat')
		fun = predict_num_adjacent(1000);
	elseif isequal(name, 'adjacent-slight-cheat')
		fun = predict_num_adjacent('slight');
	elseif isequal(name, 'adjacent-slighter-cheat')
		fun = predict_num_adjacent(10);
	elseif isequal(name, 'adjacent-cheat-tune')
		cheatfactors = [0,2,5,7,10,15,20,25,30,40,50,1000];
		fun = predict_tune_cross_validate(cheatfactors,@predict_num_adjacent,'cv_type',opts.cv_type);
	else
		error('Unknown method: %s',name);
	end
end
