function ff = predict_num_adjacent(cheat_factor)
	if nargin < 1, cheat_factor = 0; end
	ff = @(varargin) predict_num_adjacent_(cheat_factor, varargin{:});
end

function [y2,info] = predict_num_adjacent_(cheat_factor, y,ka,kb,missing)
	info = struct();
	
	neigh = bsxfun(@plus, sum(y,1), sum(y,2));
	
	cheat_row = sum(y,1) == 0;
	cheat_col = sum(y,2) == 0;
	% for row/column-wise
	if all(sum(missing,1)==0 | sum(missing,1)==size(missing,1))
		cheat_row = cheat_row & ~all(missing,1);
	end
	if all(sum(missing,2)==0 | sum(missing,2)==size(missing,2))
		cheat_col = cheat_col & ~all(missing,2);
	end
	cheat = bsxfun(@or, cheat_row, cheat_col);
	
	if isequal(cheat_factor,'slight')
		cheat_factor = mean(neigh(y==1));
	end
	
	%cheating_for = nnz(cheat)
	%num_missing = nnz(missing)
	%cheating_for_missing = nnz(cheating_for & missing)
	
	y2 = neigh + cheat_factor * cheat;
	info.cheat_factor = cheat_factor;
end
