%
dataset = 'e';
data = load_dataset(dataset);

for nfold = [0,10]

opts.num_folds = nfold;
opts.num_repetitions = 1000;
if nfold == 0
	filename = sprintf('paper/plot-adjacent-prb-loocv-%s',dataset);
else
	filename = sprintf('paper/plot-adjacent-prb-%dfold-%s',nfold,dataset);
end

[na,nb] = size(data.y);
if opts.num_folds == 0
	opts.num_repetitions = 1;
else
	division = repmat(1:opts.num_folds,1,ceil(na*nb/opts.num_folds)); % = [1,2,3,1,2,3,1,2,3,...]
end

c1 = zeros(200,200); % tally positive instances given this many neighbors
cz = zeros(200,200);
for rep = 1:opts.num_repetitions
	if opts.num_folds == 0
	    % loo
        sc1 = repmat(sum(data.y,1), [size(data.y,1),1]) - data.y;
        sc2 = repmat(sum(data.y,2), [1,size(data.y,2)]) - data.y;
	else
	    which = division(randperm(na*nb));
	    which = reshape(which, size(data.y));
	    sc1 = zeros(size(data.y));
	    sc2 = zeros(size(data.y));
	    for fold=1:opts.num_folds
	        train = data.y & which ~= fold;
	        s1 = repmat(sum(train,1), [size(train,1),1]);
	        s2 = repmat(sum(train,2), [1,size(train,2)]);
	        sc1(which==fold) = s1(which==fold);
	        sc2(which==fold) = s2(which==fold);
	    end
	end
	c1 = c1 + accumarray([sc1(:)+1,sc2(:)+1],data.y(:),size(c1));
    cz = cz + accumarray([sc1(:)+1,sc2(:)+1],1,size(cz));
end
%c1 = c1 ./ opts.num_repetitions;
%cz = cz ./ opts.num_repetitions;
imagesc(((c1+1)./(cz+2))(1:50,1:50))

% Okay, now make 1d version
f=@(i,j) i+j;
[i,j,v]=find(c1); c1b=accumarray(f(i,j),v,[1,200]);
[i,j,v]=find(cz); czb=accumarray(f(i,j),v,[1,200]);
k=1;a=0.05/2;
clb = betainv(a,c1b+k,czb-c1b+k);
cub = betainv(1-a,c1b+k,czb-c1b+k);
mk=1;%0.05;
cmb = (c1b+mk)./(czb+2*mk);

n=65;
plot((1:n)-1,[clb;cub](:,1:n));

% print to file
f = fopen([filename,'.tex'],'wt');
fprintf(f,'\\addplot+[error bars/.cd,y dir=both,y explicit] coordinates {\n');
for i=1:n
	x=i-1;
	y=(cub(i)+clb(i))/2;
	yv=(cub(i)-clb(i))/2;
	fprintf(f,'  (%f,%f) +- (%f,%f)\n', x,y, 0,yv);
end
fprintf(f,'};\n');
fclose(f);

f = fopen([filename,'-closed.tex'],'wt');
fprintf(f,'\\addplot+[fill] coordinates {\n');
for i=1:n
	fprintf(f,'  (%f,%f)\n', i-1,cub(i));
end
for i=n:-1:1
	fprintf(f,'  (%f,%f)\n', i-1,clb(i));
end
fprintf(f,'};\n');
fprintf(f,'\\addplot+[] coordinates {\n');
for i=1:n
	fprintf(f,'  (%f,%f)\n', i-1,cmb(i));
end
fprintf(f,'};\n');
fclose(f);

end
