
function stats = stats_for_multiple_cross_validates(results_list, varargin)
	% Calculate statistics of a multiple runs from run_cross_validate.
	% 
	% Usage:
	%   stats = stats_for_multiple_cross_validates({results1,results2,...}, varargin)
	% 
	% Options:
	%    'score_type',X: how to do the scoring? Possible values:
	%       'per_repetition' (default)
	%       'per_fold'
	%       'per_row'
	%       'per_column'
	%       'automatic': depending on cv_type
	%    'num_bootstraps': how many bootstrap rounds to perform
	
	scores = cell(size(results_list));
	for i = 1:numel(results_list)
		[a,s] = group_for_cross_validate(results_list{i}, varargin{:});
		if i == 1
			actuals = a;
		else
			assert(isequal(actuals,a));
		end
		scores{i} = s;
	end
	
	stats = stats_for_multiple_predictions(actuals, scores, varargin{:});
end

